#include "types.h"

extern "C" void XlatWSCBuffer(uint8 *p,uint8 *s);
extern "C" void XlatWSCBufferZoom(uint8 *p,uint8 *s);

////////////////////////////////////////////////////////////////////////////////
// VERY SLOW !!!!
////////////////////////////////////////////////////////////////////////////////
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////
void ws_rotate_backbuffer(int16 *backbuffer)
{
	static int16	temp[224*144];
	memcpy(temp,backbuffer,224*144*2);

	for (int line=0;line<144;line++)
		for (int column=0;column<224;column++)
			backbuffer[line+((223-column)<<7)+((223-column)<<4)]=temp[column+(line<<7)+(line<<6)+(line<<5)];
}
////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////

#define CLOCKS_PER_SEC 1000

volatile unsigned int framecount;

void ws_emulate_standard(void)
{	
	uint8 *pos;
	int i,j;
	
	uint32		 startTime, endTime, totalFrames;
	unsigned int nNormalLast=0;
	int			 nNormalFrac=0; 
	int			 nTime=0,nCount=0;
	uint32 framecounter;
	

	int16 *backbuffer;
	

	app_rotated=0;		
	if (app_rotated)
	{		
		#include "filter_partB.h"
		
		while (1)
		{
				#include "filter_partC.h"
		
				#include "filter_partD.h"
				//ws_rotate_backbuffer(backbuffer);
				
				XlatWSCBufferZoom((uint8*)backbuffer,(uint8*)(&gpDraw[nflip])->ptbuffer);
				
				
				
			
		}
		#include "filter_partE.h"
	}
	else
	{		
			
		backbuffer=(int16*)malloc(224*144*sizeof(int16));		
		memset(backbuffer,0x00,224*144*sizeof(int16));
		totalFrames=0;
		startTime=GpTickCountGet();
		framecount=0;
		framecounter=0;		
		int ExKey;
		int zoomed=0;
		int protectkey=0;
		int fastforward=0;
		char ch[256];
				
		while (1)
		{						
			
			
			/*GpKeyGetEx(&ExKey);
			
			//select + start 
			if ( (ExKey&GPC_VK_FR)&&(ExKey&GPC_VK_FL)&&(ExKey&GPC_VK_START)&&(ExKey&GPC_VK_SELECT) ) 
			{
				GpAppExit();
			}
			if (ExKey&GPC_VK_FL)
			{
				fastforward=1;
			}
			else
			{
				if (fastforward)
				{
					framecounter=framecount;
				}
				fastforward=0;
			}
			
			if (ExKey&GPC_VK_FR)
			{
				if (ExKey&GPC_VK_RIGHT) ws_cyclesByLine+=10;
				if (ExKey&GPC_VK_LEFT) ws_cyclesByLine-=10;
				sprintf(ch,"%d",ws_cyclesByLine);
				GpRectFill(NULL,(&gpDraw[nflip]),0,0,32,16,0);
				GpTextOut(NULL,(&gpDraw[nflip]),0,0,ch,0x1f);
			}
			
			if ( (ExKey&GPC_VK_SELECT)&&(!protectkey) ) 
			{
				zoomed^=1;
				if (!zoomed) memset((uint8*)(&gpDraw[nflip])->ptbuffer,0,240*320*2);
				protectkey=10;
			}
			
			if (ExKey&GPC_VK_START)	ws_key_start=1;
			else ws_key_start=0;
			if (ExKey&GPC_VK_FA) ws_key_button_1=1;
			else ws_key_button_1=0;
			if (ExKey&GPC_VK_FB) ws_key_button_2=1;
			else ws_key_button_2=0;
			if (ExKey&GPC_VK_LEFT) ws_key_left=1;
			else ws_key_left=0;
			if (ExKey&GPC_VK_RIGHT) ws_key_right=1;
			else ws_key_right=0;
			if (ExKey&GPC_VK_UP) ws_key_up=1;
			else ws_key_up=0;
			if (ExKey&GPC_VK_DOWN) ws_key_down=1;
			else ws_key_down=0;
				
			*/


			/*if (!fastforward)
			{
				framecounter++;
				while (framecount<framecounter)
				{
					asm volatile (
					"nop\nnop\nnop\nnop\nnop\n"
					);
				}
				nCount=framecounter-framecount;			
			}
			else nCount=9;
						
			if (nCount>9) 
			{
				framecounter=framecount-9;
				nCount=9;
			}*/
			
			/*for (i=0;i<nCount-1;i++) 
			while (!ws_executeLine(backbuffer,0));*/

			while (!ws_executeLine(backbuffer,1));
			totalFrames++;
			//XlatWSCBuffer((uint8*)backbuffer,(uint8*)(&gpDraw[nflip])->ptbuffer);
			if (zoomed) XlatWSCBufferZoom((uint8*)backbuffer,(uint8*)(&gpDraw[nflip])->ptbuffer);
			else XlatWSCBuffer((uint8*)backbuffer,(uint8*)(&gpDraw[nflip])->ptbuffer);
			
			if (protectkey) protectkey--;
			
		}
		endTime=GpTickCountGet();
		float fps=totalFrames/(((float)(endTime-startTime))/(float)CLOCKS_PER_SEC);
		

	}
}
