// state.c

#include "shared.h"

#define READ(val, size) READ_STREAM(val,size,file)
#define WRITE(val, size) WRITE_STREAM(val,size, file)

extern char RomPath[260];
extern char tg16Z_curVolume;


void GetStateFileName(int num,char *str)
{
	char result[256];
	uint32 i=0,j=255,k=255,l=255;
	char chaine[256];  	
	i=0;
	j=255;
	k=-1;
	while (RomPath[i]!=0) 
	{
		if (RomPath[i]=='.') j=i;
		if (RomPath[i]=='/') k=i;
		if (RomPath[i]=='\\') k=i;
		i++;
	  }
	if (j==255) j=i;  //pas d'extension	  
	memcpy(result,RomPath+k+1,j+1-k-1);    
	result[j+1-k-1]=0;
	if (num>=0)
	  {
	  strcat(result,"ps");
	  sprintf(str,"%s%s%d",TG16Z_SAVESDIR,result,num);
	  } 
	  else 
	  {
  		strcat(result,"srm");
	  	sprintf(str,"%s%s",TG16Z_SAVESDIR,result);
	  }


	str[0]=tg16Z_curVolume+'0';
}

int state_load(int num,int onlytest)
{
	uint32	tmp32;
	STREAM	file;
	uint32	sig;
	int i;
	int		height, width;
	char savename[255];
	
	GetStateFileName(num,savename);
	
	file = OPEN_STREAM(savename, "rb");
	if (file == NULL)
	{
		return -1;
	}
	
	
	// Close it
	CLOSE_STREAM(file);
	
	return 0;
}

int state_save(int num)
{
	uint32	tmp32;
	STREAM	file;
	uint32	sig;	
	char savename[255];
	
	GetStateFileName(num,savename);
	
	file = OPEN_STREAM(savename, "w+b");
	if (file == NULL)
	{
		return -1;
	}
	
	menu_message("Saving");

	
	// Close it
	CLOSE_STREAM(file);
	return 0;
}