//---------------------------------------------------------------------------
// NEOPOP : Emulator as in Dreamland
//
// Copyright (c) 2001-2002 by neopop_uk
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version. See also the license.txt file for
//	additional informations.
//---------------------------------------------------------------------------

/*
//---------------------------------------------------------------------------
//=========================================================================

	system_graphics.c

//=========================================================================
//---------------------------------------------------------------------------

  History of changes:
  ===================

20 JUL 2002 - neopop_uk
=======================================
- Cleaned and tidied up for the source release

21 JUL 2002 - neopop_uk
=======================================
- Promoted 'system_graphics_clear' with a comment heading to make it
more prominent as an emulator interface function.

06 AUG 2002 - neopop_uk
=======================================
- Optimised the graphics update, adding 6% more speed to my machine.
- Removed "system_graphics_clear" - not needed.

11 AUG 2002 - neopop_uk
=======================================
- Fixed extra blank top line in 16-bit colour mode.

22 AUG 2002 - neopop_uk
=======================================
- Added a border around the display.

27 AUG 2002 - neopop_uk
=======================================
- Added fullscreen mode.
- Optimised both modes very slightly by pre-calculating a CFB pointer, and
	performing increments instead of multiplications.

31 AUG 2002 - neopop_uk
=======================================
- Fixed the full-screen screen position, it wasn't quite central.

10 SEP 2002 - neopop_uk
=======================================
- Added left and right borders to the full-screen display so that the NVidia
filtering isn't cropped.
- Added full-screen width stretching.

//---------------------------------------------------------------------------
*/

#include "neopop.h"

#include "system_main.h"
#include "system_graphics.h"


//=============================================================================

//=============================================================================

//-----------------------------------------------------------------------------
// system_graphics_ready()
//-----------------------------------------------------------------------------
/*BOOL system_graphics_ready(void)
{
	return TRUE;

}*/


//-----------------------------------------------------------------------------
// system_graphics_update_fullscreen()
//-----------------------------------------------------------------------------
void system_graphics_update_fullscreen(void)
{
/*		int x, y;
		_u16 *row;
		_u16 r,g,b;

		_u16 r16,g16,b16, *frame16;
		_u32 w = ddsd.lPitch >> 1;

		frame16 = (_u16*)ddsd.lpSurface + (BORDER_HEIGHT * w) + BORDER_WIDTH;
		row = cfb;

		for (y = 0; y < SCREEN_HEIGHT; y++)
		{
			for (x = 0; x < SCREEN_WIDTH; x++)
			{
				//X4B4G4R ==> [0xR0G0B0]

				r = ((row[x] & 0x00F) << 4);
				g = ((row[x] & 0x0F0));
				b = ((row[x] & 0xF00) >> 4);

				r16 = ((r>>(dwRShiftL16))<<dwRShiftR16)&dwRMask16;
				g16 = ((g>>(dwGShiftL16))<<dwGShiftR16)&dwGMask16;
				b16 = ((b>>(dwBShiftL16))<<dwBShiftR16)&dwBMask16;

				frame16[x] = (r16 | g16 | b16);
			}

			frame16 += w;
			row += SCREEN_WIDTH;
		}
*/	
}

//=============================================================================
